<?php

namespace Drupal\qtools_common;

use Drupal\qtools_common\Utility\QtoolsConfigurableInterface;

/**
 * Collects all services that are using qtools configuration.
 */
class QtoolsConfigurableServicesCollector {

  /**
   * Default configuration.
   *
   * @var array
   */
  protected $configDefaults = [];

  /**
   * Combine configs from configurable services.
   */
  public function addHandler(QtoolsConfigurableInterface $service): void {
    $this->configDefaults[$service->getConfigTraitBundle()] = $service->getConfigTraitDefaults();
  }

  /**
   * Returns configuration merged from all services.
   */
  public function getDefaultConfigurations(): array {
    return $this->configDefaults;
  }

}
