<?php

namespace Drupal\qtools_common\Twig;

use Twig\Extension\AbstractExtension;
use Twig\TwigFunction;

/**
 * Dpm passed variable.
 */
class QdpmExtension extends AbstractExtension {

  /**
   * {@inheritdoc}
   */
  public function getName() {
    return 'qdpm';
  }

  /**
   * {@inheritdoc}
   */
  public function getFunctions() {
    return [
      new TwigFunction('qdpm', [$this, 'qDpmFunction'], ['is_safe' => ['html']]),
    ];
  }

  /**
   * Dumps variable.
   */
  public function qDpmFunction($data, $title = NULL) {
    $printer = function_exists('qpm') ?
      'qpm' :
      'dpm';

    if (!function_exists($printer)) {
      return;
    }

    if ($title !== NULL) {
      $printer($data, $title);
    }
    else {
      $printer($data);
    }

  }

}
